%This function identifies the modes from the pair of turning points Y
%The rest of the inputs are K, the number of clusters, start (peak or
%trough and the minimun distance between cyclical phase
function [M,mukmod1,mukmod2,covarkmod,Skmod]=Kmodes_bi_empirical(Y,K,start,dist)
[N,r]=size(Y);
if start==1 %start with peaks
    y=Y(:,1);
    x=Y(:,2);
elseif start==2 %start with trougts
    y=Y(:,1);
    x=Y(:,2);
end
U = unique(y);
H=histc(y,U);
U(H==max(H));
[~,index]=sort(H,'descend');
B=U(index);
%M=B(1:K);

%Check the minimun distance l
M=NaN(K,1);
M(1)=B(1);
i=2; l=2;
while (i<=length(B))
sw=0;
j=1;
while (j<l)
    d=calculate_distance(B(i),M(j));
    if d<dist
        sw=1;
    end
     j=j+1;
end
  if sw==0
      M(l)=B(i);
      l=l+1;
  end
  if l==K+1
      break
  end
  i=i+1;
end

Skmod=NaN(length(y),1);
for i=1:length(y)
    for j=1:K
        d(j)=abs(y(i)-M(j));
    end
    [~,index]=min(d);
    Skmod(i)=index;
end

Skmod=arrange_classification(y,Skmod);
Skmod=Skmod';

mukmod1=NaN(1,K);
varkmod1=NaN(1,K);
mukmod2=NaN(1,K);
varkmod2=NaN(1,K);
covarkmod=NaN(2,2,K);


ind=repmat(Skmod',K,1)==repmat([1:K]',1,N);
Nk=sum(ind,2)';  % This is 1xK vector Nk(s) 
for i=1:K
mukmod1(i)=mean(y(Skmod==i));
varkmod1(i)=var(y(Skmod==i));
mukmod2(i)=mean(x(Skmod==i));
varkmod2(i)=var(x(Skmod==i));
covarkmod(:,:,i)=cov(y(Skmod==i),x(Skmod==i));
%Include a warning if there is a cluster empty
if sum(sum(isnan(covarkmod(:,:,i))))==4
    %fprintf('There is a cluster empty. TOO MANY CLUSTERS FOR THE CHARACTERISTICS OF THE DATA. REDUCE K\n')
else
vp=eig(covarkmod(:,:,i));
vpneg=find(vp<=0);
%Include a warning if some cov matrix is not positive semi-definited, 
%probably because one of the variance is close to zero; this
%problem can appears when the number of clusters is excesive, the number of
%observations in a cluster is too small or the priors are not suitable
if sum(vpneg)>0
    %fprintf('The covar matrix it is not semi-positive defined\n')
    covarkmod(:,:,i)=covarkmod(:,:,i)+r*eye(r);
end
end
end


function b=arrange_classification(date,S)
A=[date,S];
B=A;
a=0; b=0;
for i=1:size(A,1)
    if A(i,2)~=a
        b=b+1;
        a=A(i,2);
    end
     B(i,2)=b;
end
b=B(:,2)';

function dis=calculate_distance(a,b)
a=decimals_to_months(a);
b=decimals_to_months(b);
    if floor(a)==floor(b)
        dis=abs(a-b)*12;
    else
        dis=round(abs(floor(a)-floor(b))*12+abs((a-floor(a))-(b-floor(b))*100)-1);
    end  

