function Sperm=compute_similarity_matrix(S,K)

 
    SM=size(S,1);
    N=size(S,2);    
    if N<=1000
        jointclass=zeros(N);
        for k=1:K
            jointclass=jointclass+double(S==k)'*(S==k);
        end
        jointclass=jointclass/SM; % approximate similarity matrix
        Wloss=1-2*jointclass; clear jointclass;
        
        % compute loss function 
        lossim=zeros(SM,1); 
        for m=1:SM;
            lossim(m)=sum(sum(Wloss.*(repmat(S(m,:),N,1)==repmat(S(m,:),N,1)')));                       
        end        
    else        
        lossim=mcmcclustsim(S,K);         
    end

    clear Wloss;
    
    [~, is]=sort(lossim); 
    clust.Ssim=S(is(1),:);    
    Nk=sum(repmat(clust.Ssim,K,1)==repmat((1:K)',1,N),2);
    [~,is]=sort(Nk);
    isa=is(end:-1:1);
    for k=1:K; 
        Sperm(clust.Ssim==isa(k))=k; % gruppen werden der Groesse nach sortiert
    end
    clust.Ssim=Sperm;
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function lossim= mcmcclustsim(S,K)

% classification based on the similarity matrix
% computes the loss function

N=size(S,2);
SM=size(S,1);
Wloss= zeros(N);  
index=1:N;
for m=1:SM;
    ['m = ' num2str(m) '(max:' num2str(SM) ')']
    for k=1:K
        id=index(S(m,:)==k); % index  of all observations in group k
        Wloss(id,id)=Wloss(id,id)+1;
    end
end

%  Wloss/SM ...  approximate similarity matrix
Wloss=1-2*Wloss/SM; 

lossim=zeros(SM,1); 
for m=1:SM;
    ['m = ' num2str(m) '(max:' num2str(SM) ')'];
    for k=1:K
        id=index(S(m,:)==k);
        lossim(m)=sum(sum(Wloss(id,id)));
    end
end

