function Qcol=manipulate_matrix(Q,n)
if n==1
    Qcol=qincol(Q);
elseif n==2
    Qcol=qincolmult(Q);
elseif n==3
    Qcol=qinmatr(Q);
elseif n==4
    Qcol=qinmatrmult(Q);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Qcol = qincol(Q)
% wandelt eine quadrat Matrix der dim dd in eine Spalte der dim dd*(dd+1)/2 um
% wobei nur die obige Dreiecksmatrix spaltenweise hintereinander geschrieben wird

% input: Q .. ddxdd
% output: Qcol .. dd*(dd+1)/2x1
dd = size(Q,2);
hilf = 0;
for i = 1:dd,
   Qcol(hilf+1:hilf+i,1) = Q(1:i,i);
   hilf =hilf + i;
end   

function Qcol = qincolmult(Q)
% wandelt eine quadrat Matrix der dim dd in eine Spalte der dim dd*(dd+1)/2 um
% wobei nur die obige Dreiecksmatrix spaltenweise hintereinander geschrieben wird

% input: Q .. ddxdd
% output: Qcol .. dd*(dd+1)/2x1
dd = size(Q,2);
k=size(Q,3);
Qcol=zeros(dd,k);
for j=1:k
hilf = 0;
for i = 1:dd,
   Qcol(hilf+1:hilf+i,j) = Q(1:i,i,j);
   hilf =hilf + i;
end   
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Q = qinmatr(Qcol)

% fuer symm. Matrizen Umkehrung zu Programm qincol

% wandelt eine Spalte der dim dd*(dd+1)/2 eine quadrat Matrix der dim dd in eine quadrat Matrix der dim dd um
% wobei die Elemente der Spalte in die obige Dreiecksmatrix spaltenweise nebeneinander geschrieben werden
% und die Matrix zu einer symmetr. Matrix ergaenzt wird

% input: Qcol .. [dd*(dd+1)/2]x1
% output: Q .. ddxdd

D = size(Qcol,1);

dd = -.5 + (.25 + 2*D)^.5;

if ~(fix(dd)==dd) 
    warn('size inconsistency in function qinmatr');
end

hilf = 0;
for i = 1:dd,
   Q(1:i,i) = Qcol(hilf+1:hilf+i,1);
   Q(i,1:i) = Qcol(hilf+1:hilf+i,1)';
   hilf =hilf + i;
end   

function Q = qinmatrmult(Qcol)

% fuer symm. Matrizen Umkehrung zu Programm qincol

% wandelt eine Spalte der dim dd*(dd+1)/2 eine quadrat Matrix der dim dd in eine quadrat Matrix der dim dd um
% wobei die Elemente der Spalte in die obige Dreiecksmatrix spaltenweise nebeneinander geschrieben werden
% und die Matrix zu einer symmetr. Matrix ergaenzt wird

% input: Qcol .. [dd*(dd+1)/2]x1
% output: Q .. ddxdd

D = size(Qcol,1);

k=size(Qcol,2);
dd = -.5 + (.25 + 2*D)^.5;

if ~(fix(dd)==dd) 
    warn('size inconsistency in function qinmatrmult');
end

Q=zeros(dd,dd,k);

for j=1:k
     
    hilf = 0;
    for i = 1:dd,
        Q(1:i,i,j) = Qcol(hilf+1:hilf+i,j);
        Q(i,1:i,j) = Qcol(hilf+1:hilf+i,j)';
        hilf =hilf + i;
    end   
    
end